Index: src/moleculelist.cpp
===================================================================
--- src/moleculelist.cpp	(revision 8c54a3b5f6bdf770309a91dff75fb62f47d91b6d)
+++ src/moleculelist.cpp	(revision 0dbddc24a89f547aa564634e7647f87ec8ce9700)
@@ -35,9 +35,8 @@
  * \return true - add successful
  */
-bool MoleculeListClass::insert(molecule *mol)
+void MoleculeListClass::insert(molecule *mol)
 {
   mol->IndexNr = MaxIndex++;
   ListOfMolecules.push_back(mol);
-  return true;
 };
 
@@ -128,30 +127,37 @@
   atom *Walker = NULL;
   int Counts[MAX_ELEMENTS];
+  double size=0;
+  Vector Origin;
 
   // header
-  *out << "Index\tName\tNo.Atoms\tformula" << endl;
+  *out << "Index\tName\t\tAtoms\tFormula\tCenter\tSize" << endl;
   cout << Verbose(0) << "-----------------------------------------------" << endl;
   if (ListOfMolecules.size() == 0)
     *out << "\tNone" << endl;
   else {
+    Origin.Zero();
     for (MoleculeList::iterator ListRunner = ListOfMolecules.begin(); ListRunner != ListOfMolecules.end(); ListRunner++) {
       // reset element counts
       for (int j = 0; j<MAX_ELEMENTS;j++)
         Counts[j] = 0;
-      // count atoms per element
+      // count atoms per element and determine size of bounding sphere
+      size=0.;
       Walker = (*ListRunner)->start;
       while (Walker->next != (*ListRunner)->end) {
         Walker = Walker->next;
         Counts[Walker->type->Z]++;
+        if (Walker->x.DistanceSquared(&Origin) > size)
+          size = Walker->x.DistanceSquared(&Origin);
       }
       // output Index, Name, number of atoms, chemical formula
       *out << ((*ListRunner)->ActiveFlag ? "*" : " ") << (*ListRunner)->IndexNr << "\t" << (*ListRunner)->name << "\t\t" << (*ListRunner)->AtomCount << "\t";
       Elemental = (*ListRunner)->elemente->end;
-      while(Elemental != (*ListRunner)->elemente->start) {
+      while(Elemental->previous != (*ListRunner)->elemente->start) {
         Elemental = Elemental->previous;
         if (Counts[Elemental->Z] != 0)
           *out << Elemental->symbol << Counts[Elemental->Z];
       }
-      *out << endl;
+      // Center and size
+      *out << "\t" << (*ListRunner)->Center << "\t" << sqrt(size) << endl;
     }
   }
@@ -164,11 +170,8 @@
 molecule * MoleculeListClass::ReturnIndex(int index)
 {
-  int count = 1;
-  MoleculeList::iterator ListRunner = ListOfMolecules.begin();
-  for(; ((ListRunner != ListOfMolecules.end()) && (count < index)); ListRunner++);
-  if (count == index)
-    return (*ListRunner);
-  else
-    return NULL;
+  for(MoleculeList::iterator ListRunner = ListOfMolecules.begin(); ListRunner != ListOfMolecules.end(); ListRunner++)
+    if ((*ListRunner)->IndexNr == index)
+      return (*ListRunner);
+  return NULL;
 };
 
@@ -523,5 +526,5 @@
 
   // open file for the force factors
-  *out << Verbose(1) << "Saving	force factors ... ";
+  *out << Verbose(1) << "Saving  force factors ... ";
   line << path << "/" << FRAGMENTPREFIX << FORCESFILE;
   ForcesFile.open(line.str().c_str(), ios::out);
@@ -565,8 +568,9 @@
  * \param *configuration standard configuration to attach atoms in fragment molecule to.
  * \param *SortIndex Index to map from the BFS labeling to the sequence how of Ion_Type in the config
+ * \param DoPeriodic true - call ScanForPeriodicCorrection, false - don't
+ * \param DoCentering true - call molecule::CenterEdge(), false - don't
  * \return true - success (each file was written), false - something went wrong.
  */
-bool MoleculeListClass::OutputConfigForListOfFragments(ofstream *out,
-    config *configuration, int *SortIndex)
+bool MoleculeListClass::OutputConfigForListOfFragments(ofstream *out, config *configuration, int *SortIndex)
 {
   ofstream outputFragment;
@@ -691,9 +695,9 @@
 MoleculeLeafClass::MoleculeLeafClass(MoleculeLeafClass *PreviousLeaf = NULL)
 {
-  //	if (Up != NULL)
-  //		if (Up->DownLeaf == NULL) // are we the first down leaf for the upper leaf?
-  //			Up->DownLeaf = this;
-  //	UpLeaf = Up;
-  //	DownLeaf = NULL;
+  //  if (Up != NULL)
+  //    if (Up->DownLeaf == NULL) // are we the first down leaf for the upper leaf?
+  //      Up->DownLeaf = this;
+  //  UpLeaf = Up;
+  //  DownLeaf = NULL;
   Leaf = NULL;
   previous = PreviousLeaf;
@@ -711,14 +715,14 @@
 MoleculeLeafClass::~MoleculeLeafClass()
 {
-  //	if (DownLeaf != NULL) {// drop leaves further down
-  //		MoleculeLeafClass *Walker = DownLeaf;
-  //		MoleculeLeafClass *Next;
-  //		do {
-  //			Next = Walker->NextLeaf;
-  //			delete(Walker);
-  //			Walker = Next;
-  //		} while (Walker != NULL);
-  //		// Last Walker sets DownLeaf automatically to NULL
-  //	}
+  //  if (DownLeaf != NULL) {// drop leaves further down
+  //    MoleculeLeafClass *Walker = DownLeaf;
+  //    MoleculeLeafClass *Next;
+  //    do {
+  //      Next = Walker->NextLeaf;
+  //      delete(Walker);
+  //      Walker = Next;
+  //    } while (Walker != NULL);
+  //    // Last Walker sets DownLeaf automatically to NULL
+  //  }
   // remove the leaf itself
   if (Leaf != NULL) {
@@ -729,11 +733,11 @@
   if (previous != NULL)
     previous->next = next;
-  //	} else { // we are first in list (connects to UpLeaf->DownLeaf)
-  //		if ((NextLeaf != NULL) && (NextLeaf->UpLeaf == NULL))
-  //			NextLeaf->UpLeaf = UpLeaf;	// either null as we are top level or the upleaf of the first node
-  //		if (UpLeaf != NULL)
-  //			UpLeaf->DownLeaf = NextLeaf;	// either null as we are only leaf or NextLeaf if we are just the first
-  //	}
-  //	UpLeaf = NULL;
+  //  } else { // we are first in list (connects to UpLeaf->DownLeaf)
+  //    if ((NextLeaf != NULL) && (NextLeaf->UpLeaf == NULL))
+  //      NextLeaf->UpLeaf = UpLeaf;  // either null as we are top level or the upleaf of the first node
+  //    if (UpLeaf != NULL)
+  //      UpLeaf->DownLeaf = NextLeaf;  // either null as we are only leaf or NextLeaf if we are just the first
+  //  }
+  //  UpLeaf = NULL;
   if (next != NULL) // are we last in list
     next->previous = previous;
Index: src/molecules.cpp
===================================================================
--- src/molecules.cpp	(revision 8c54a3b5f6bdf770309a91dff75fb62f47d91b6d)
+++ src/molecules.cpp	(revision 0dbddc24a89f547aa564634e7647f87ec8ce9700)
@@ -16,15 +16,15 @@
 double LSQ (const gsl_vector * x, void * params)
 {
-	double sum = 0.;
-	struct LSQ_params *par = (struct LSQ_params *)params;
-	Vector **vectors = par->vectors;
-	int num = par->num;
-
-	for (int i=num;i--;) {
-		for(int j=NDIM;j--;)
-			sum += (gsl_vector_get(x,j) - (vectors[i])->x[j])*(gsl_vector_get(x,j) - (vectors[i])->x[j]);
-	}
-
-	return sum;
+  double sum = 0.;
+  struct LSQ_params *par = (struct LSQ_params *)params;
+  Vector **vectors = par->vectors;
+  int num = par->num;
+
+  for (int i=num;i--;) {
+    for(int j=NDIM;j--;)
+      sum += (gsl_vector_get(x,j) - (vectors[i])->x[j])*(gsl_vector_get(x,j) - (vectors[i])->x[j]);
+  }
+
+  return sum;
 };
 
@@ -36,31 +36,33 @@
 molecule::molecule(periodentafel *teil)
 {
-	// init atom chain list
-	start = new atom;
-	end = new atom;
-	start->father = NULL;
-	end->father = NULL;
-	link(start,end);
-	// init bond chain list
-	first = new bond(start, end, 1, -1);
-	last = new bond(start, end, 1, -1);
-	link(first,last);
-	// other stuff
-	MDSteps = 0;
-	last_atom = 0;
-	elemente = teil;
-	AtomCount = 0;
-	BondCount = 0;
-	NoNonBonds = 0;
-	NoNonHydrogen = 0;
-	NoCyclicBonds = 0;
-	ListOfBondsPerAtom = NULL;
-	NumberOfBondsPerAtom = NULL;
-	ElementCount = 0;
-	for(int i=MAX_ELEMENTS;i--;)
-		ElementsInMolecule[i] = 0;
-	cell_size[0] = cell_size[2] = cell_size[5]= 20.;
-	cell_size[1] = cell_size[3] = cell_size[4]= 0.;
-	strcpy(name,"none");
+  // init atom chain list
+  start = new atom;
+  end = new atom;
+  start->father = NULL;
+  end->father = NULL;
+  link(start,end);
+  // init bond chain list
+  first = new bond(start, end, 1, -1);
+  last = new bond(start, end, 1, -1);
+  link(first,last);
+  // other stuff
+  MDSteps = 0;
+  last_atom = 0;
+  elemente = teil;
+  AtomCount = 0;
+  BondCount = 0;
+  NoNonBonds = 0;
+  NoNonHydrogen = 0;
+  NoCyclicBonds = 0;
+  ListOfBondsPerAtom = NULL;
+  NumberOfBondsPerAtom = NULL;
+  ElementCount = 0;
+  for(int i=MAX_ELEMENTS;i--;)
+    ElementsInMolecule[i] = 0;
+  cell_size[0] = cell_size[2] = cell_size[5]= 20.;
+  cell_size[1] = cell_size[3] = cell_size[4]= 0.;
+  strcpy(name,"none");
+  IndexNr  = -1;
+  ActiveFlag = false;
 };
 
@@ -70,14 +72,14 @@
 molecule::~molecule()
 {
-	if (ListOfBondsPerAtom != NULL)
-		for(int i=AtomCount;i--;)
-			Free((void **)&ListOfBondsPerAtom[i], "molecule::~molecule: ListOfBondsPerAtom[i]");
-	Free((void **)&ListOfBondsPerAtom, "molecule::~molecule: ListOfBondsPerAtom");
-	Free((void **)&NumberOfBondsPerAtom, "molecule::~molecule: NumberOfBondsPerAtom");
-	CleanupMolecule();
-	delete(first);
-	delete(last);
-	delete(end);
-	delete(start);
+  if (ListOfBondsPerAtom != NULL)
+    for(int i=AtomCount;i--;)
+      Free((void **)&ListOfBondsPerAtom[i], "molecule::~molecule: ListOfBondsPerAtom[i]");
+  Free((void **)&ListOfBondsPerAtom, "molecule::~molecule: ListOfBondsPerAtom");
+  Free((void **)&NumberOfBondsPerAtom, "molecule::~molecule: NumberOfBondsPerAtom");
+  CleanupMolecule();
+  delete(first);
+  delete(last);
+  delete(end);
+  delete(start);
 };
 
@@ -89,23 +91,23 @@
 bool molecule::AddAtom(atom *pointer)
 {
-	if (pointer != NULL) {
-		pointer->sort = &pointer->nr;
-		pointer->nr = last_atom++;	// increase number within molecule
-		AtomCount++;
-		if (pointer->type != NULL) {
-			if (ElementsInMolecule[pointer->type->Z] == 0)
-				ElementCount++;
-			ElementsInMolecule[pointer->type->Z]++; // increase number of elements
-			if (pointer->type->Z != 1)
-				NoNonHydrogen++;
-			if (pointer->Name == NULL) {
-				Free((void **)&pointer->Name, "molecule::AddAtom: *pointer->Name");
-				pointer->Name = (char *) Malloc(sizeof(char)*6, "molecule::AddAtom: *pointer->Name");
-				sprintf(pointer->Name, "%2s%02d", pointer->type->symbol, pointer->nr+1);
-			}
-		}
-		return add(pointer, end);
-	} else
-		return false;
+  if (pointer != NULL) {
+    pointer->sort = &pointer->nr;
+    pointer->nr = last_atom++;  // increase number within molecule
+    AtomCount++;
+    if (pointer->type != NULL) {
+      if (ElementsInMolecule[pointer->type->Z] == 0)
+        ElementCount++;
+      ElementsInMolecule[pointer->type->Z]++; // increase number of elements
+      if (pointer->type->Z != 1)
+        NoNonHydrogen++;
+      if (pointer->Name == NULL) {
+        Free((void **)&pointer->Name, "molecule::AddAtom: *pointer->Name");
+        pointer->Name = (char *) Malloc(sizeof(char)*6, "molecule::AddAtom: *pointer->Name");
+        sprintf(pointer->Name, "%2s%02d", pointer->type->symbol, pointer->nr+1);
+      }
+    }
+    return add(pointer, end);
+  } else
+    return false;
 };
 
@@ -117,22 +119,16 @@
 atom * molecule::AddCopyAtom(atom *pointer)
 {
-	if (pointer != NULL) {
-		atom *walker = new atom();
-		walker->type = pointer->type;	// copy element of atom
-		walker->x.CopyVector(&pointer->x); // copy coordination
-		walker->v.CopyVector(&pointer->v); // copy velocity
-		walker->FixedIon = pointer->FixedIon;
-		walker->sort = &walker->nr;
-		walker->nr = last_atom++;	// increase number within molecule
-		walker->father = pointer; //->GetTrueFather();
-		walker->Name = (char *) Malloc(sizeof(char)*strlen(pointer->Name)+1, "molecule::AddCopyAtom: *Name");
-		strcpy (walker->Name, pointer->Name);
-		add(walker, end);
-		if ((pointer->type != NULL) && (pointer->type->Z != 1))
-			NoNonHydrogen++;
-		AtomCount++;
-		return walker;
-	} else
-		return NULL;
+  if (pointer != NULL) {
+    atom *walker = new atom(pointer);
+    walker->Name = (char *) Malloc(sizeof(char)*strlen(pointer->Name)+1, "atom::atom: *Name");
+    strcpy (walker->Name, pointer->Name);
+    walker->nr = last_atom++;  // increase number within molecule
+    add(walker, end);
+    if ((pointer->type != NULL) && (pointer->type->Z != 1))
+      NoNonHydrogen++;
+    AtomCount++;
+    return walker;
+  } else
+    return NULL;
 };
 
@@ -142,23 +138,23 @@
  * -# Single Bond: Simply add new atom with bond distance rescaled to typical hydrogen one
  * -# Double Bond: Here, we need the **BondList of the \a *origin atom, by scanning for the other bonds instead of
- *		*Bond, we use the through these connected atoms to determine the plane they lie in, vector::MakeNormalvector().
- *		The orthonormal vector to this plane along with the vector in *Bond direction determines the plane the two
- *		replacing hydrogens shall lie in. Now, all remains to do is take the usual hydrogen double bond angle for the
- *		element of *origin and form the sin/cos admixture of both plane vectors for the new coordinates of the two
- *		hydrogens forming this angle with *origin.
+ *    *Bond, we use the through these connected atoms to determine the plane they lie in, vector::MakeNormalvector().
+ *    The orthonormal vector to this plane along with the vector in *Bond direction determines the plane the two
+ *    replacing hydrogens shall lie in. Now, all remains to do is take the usual hydrogen double bond angle for the
+ *    element of *origin and form the sin/cos admixture of both plane vectors for the new coordinates of the two
+ *    hydrogens forming this angle with *origin.
  * -# Triple Bond: The idea is to set up a tetraoid (C1-H1-H2-H3) (however the lengths \f$b\f$ of the sides of the base
- *		triangle formed by the to be added hydrogens are not equal to the typical bond distance \f$l\f$ but have to be
- *		determined from the typical angle \f$\alpha\f$ for a hydrogen triple connected to the element of *origin):
- *		We have the height \f$d\f$ as the vector in *Bond direction (from triangle C1-H1-H2).
- *		\f[ h = l \cdot \cos{\left (\frac{\alpha}{2} \right )} \qquad b = 2l \cdot \sin{\left (\frac{\alpha}{2} \right)} \quad \rightarrow \quad d = l \cdot \sqrt{\cos^2{\left (\frac{\alpha}{2} \right)}-\frac{1}{3}\cdot\sin^2{\left (\frac{\alpha}{2}\right )}}
- *		\f]
- *		vector::GetNormalvector() creates one orthonormal vector from this *Bond vector and vector::MakeNormalvector creates
- *		the third one from the former two vectors. The latter ones form the plane of the base triangle mentioned above.
- *		The lengths for these are \f$f\f$ and \f$g\f$ (from triangle H1-H2-(center of H1-H2-H3)) with knowledge that
- *		the median lines in an isosceles triangle meet in the center point with a ratio 2:1.
- *		\f[ f = \frac{b}{\sqrt{3}} \qquad g = \frac{b}{2}
- *		\f]
- *		as the coordination of all three atoms in the coordinate system of these three vectors:
- *		\f$\pmatrix{d & f & 0}\f$, \f$\pmatrix{d & -0.5 \cdot f & g}\f$ and \f$\pmatrix{d & -0.5 \cdot f & -g}\f$.
+ *    triangle formed by the to be added hydrogens are not equal to the typical bond distance \f$l\f$ but have to be
+ *    determined from the typical angle \f$\alpha\f$ for a hydrogen triple connected to the element of *origin):
+ *    We have the height \f$d\f$ as the vector in *Bond direction (from triangle C1-H1-H2).
+ *    \f[ h = l \cdot \cos{\left (\frac{\alpha}{2} \right )} \qquad b = 2l \cdot \sin{\left (\frac{\alpha}{2} \right)} \quad \rightarrow \quad d = l \cdot \sqrt{\cos^2{\left (\frac{\alpha}{2} \right)}-\frac{1}{3}\cdot\sin^2{\left (\frac{\alpha}{2}\right )}}
+ *    \f]
+ *    vector::GetNormalvector() creates one orthonormal vector from this *Bond vector and vector::MakeNormalvector creates
+ *    the third one from the former two vectors. The latter ones form the plane of the base triangle mentioned above.
+ *    The lengths for these are \f$f\f$ and \f$g\f$ (from triangle H1-H2-(center of H1-H2-H3)) with knowledge that
+ *    the median lines in an isosceles triangle meet in the center point with a ratio 2:1.
+ *    \f[ f = \frac{b}{\sqrt{3}} \qquad g = \frac{b}{2}
+ *    \f]
+ *    as the coordination of all three atoms in the coordinate system of these three vectors:
+ *    \f$\pmatrix{d & f & 0}\f$, \f$\pmatrix{d & -0.5 \cdot f & g}\f$ and \f$\pmatrix{d & -0.5 \cdot f & -g}\f$.
  *
  * \param *out output stream for debugging
@@ -168,5 +164,5 @@
  * \param *replacement pointer to the atom which shall be copied as a hydrogen atom in this molecule
  * \param **BondList list of bonds \a *replacement has (necessary to determine plane for double and triple bonds)
- * \param NumBond	number of bonds in \a **BondList
+ * \param NumBond  number of bonds in \a **BondList
  * \param isAngstroem whether the coordination of the given atoms is in AtomicLength (false) or Angstrom(true)
  * \return number of atoms added, if < bond::BondDegree then something went wrong
